/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 25.2.19 - 
 */

#include "RandomSolution.h"
#include "../message.h"

namespace lib4neuro {

    RandomSolution::RandomSolution() {
        this->optimal_parameters =  new std::vector<double>();
    }

    RandomSolution::~RandomSolution() {

    }

    std::vector<double> *RandomSolution::get_parameters() {
        return this->optimal_parameters;
    }

    void RandomSolution::optimize(lib4neuro::ErrorFunction &ef, std::ofstream *ofs) {
        ef.get_network_instance()->randomize_parameters();
        *this->optimal_parameters = *ef.get_parameters();
        COUT_INFO("Producing a random solution... error: " << ef.eval(this->optimal_parameters) << std::endl);
    }

}