/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 15.3.19 -
 */

#ifndef LIB4NEURO_CONNECTIONFUNCTIONCONSTANT_H
#define LIB4NEURO_CONNECTIONFUNCTIONCONSTANT_H

#include "../settings.h"
#include "ConnectionFunctionGeneral.h"

class ConnectionFunctionConstant:public ConnectionFunctionGeneral {
private:
    double weight;

public:
    /**
     * Struct used to access private properties from
     * the serialization function
     */
    struct access;

    LIB4NEURO_API ConnectionFunctionConstant(double w = 1);

    LIB4NEURO_API ~ConnectionFunctionConstant();

    LIB4NEURO_API double eval( std::vector<double> &parameter_space ) override;

    LIB4NEURO_API void eval_partial_derivative(std::vector<double> &parameter_space, std::vector<double> &weight_gradient, double alpha) override;

};


#endif //LIB4NEURO_CONNECTIONFUNCTIONCONSTANT_H
