#ifndef LIB4NEURO_NEURONBIASEDSERIALIZATION_H
#define LIB4NEURO_NEURONBIASEDSERIALIZATION_H

#include <boost/serialization/base_object.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/export.hpp>

#include "NeuronSerialization.h"
#include "NeuronBiased.h"

BOOST_CLASS_EXPORT_KEY(lib4neuro::NeuronBiased);

struct lib4neuro :: NeuronBiased :: access {
    template <class Archive>
    static void serialize(Archive &ar, lib4neuro::NeuronBiased& n, const unsigned int version) {
        ar & boost::serialization::base_object<lib4neuro::Neuron>(n);
        ar & n.bias;
    }
};

namespace boost {
    namespace serialization {

        /**
         * Serialization function
         * @tparam Archive Boost library template
         * @param ar Boost parameter - filled automatically during serialization!
         * @param n NeuronBiased instance
         * @param version Boost parameter - filled automatically during serialization!
         */
        template<class Archive>
        void serialize(Archive & ar, lib4neuro::NeuronBiased& n, const unsigned int version)
        {
            lib4neuro::NeuronBiased::access::serialize(ar, n, version);
        }

    } // namespace serialization
} // namespace boost


#endif //LIB4NEURO_NEURONBIASEDSERIALIZATION_H
